--- mmap.orig	Wed Dec 15 11:51:51 2004
+++ mmap.c	Sat May 28 21:58:35 2005
@@ -59,7 +59,7 @@ static inline int munmap( void *ptr, siz
 #endif
 
 
-#if (defined(__svr4__) || defined(__NetBSD__)) && !defined(MAP_TRYFIXED)
+#if (defined(__svr4__) || defined(__NetBSD__) || defined(__FreeBSD__)) && !defined(MAP_TRYFIXED)
 /***********************************************************************
  *             try_mmap_fixed
  *
@@ -115,8 +115,9 @@ static int try_mmap_fixed (void *addr, s
         /* We call mincore() for every page in the desired range.
            If any of these calls succeeds, the page is already
            mapped and we must fail. */
+	/*patch for BSD testing the result of mincore not only if failed */
         for ( i = 0; i < len; i += pagesize )
-            if ( mincore( (caddr_t)addr + i, pagesize, &vec ) != -1 )
+            if ( mincore( (caddr_t)addr + i, pagesize, &vec ) != -1  && (vec&1))
                _exit(1);
 
         /* Perform the mapping with MAP_FIXED set.  This is safe
@@ -137,7 +138,7 @@ static int try_mmap_fixed (void *addr, s
 
     return result == addr;
 }
-#endif  /* (__svr4__ || __NetBSD__) && !MAP_TRYFIXED */
+#endif  /* (__svr4__ || __NetBSD__ || __FreeBSD__) && !MAP_TRYFIXED */
 
 
 /***********************************************************************
@@ -182,10 +183,21 @@ void *wine_anon_mmap( void *start, size_
 #ifdef MAP_TRYFIXED
         /* If available, this will attempt a fixed mapping in-kernel */
         flags |= MAP_TRYFIXED;
-#elif defined(__svr4__) || defined(__NetBSD__)
+
+#elif defined(__svr4__) || defined(__NetBSD__) 
         if ( try_mmap_fixed( start, size, prot, flags, fdzero, 0 ) )
             return start;
+
+#elif defined(__FreeBSD__) 
+	/* for creating system heap use this to assure the adress of start is good*/
+	if (start== (void *)0x80000000)
+		{
+		if (try_mmap_fixed( start, size, prot, flags, fdzero, 0 ) )
+		  return start;
+		TRACE("Creating System Heap in FreeBSD using try_mmap_fixed");
+		}
 #endif
+
     }
     return mmap( start, size, prot, flags, fdzero, 0 );
 #else
@@ -249,6 +261,7 @@ static void reserve_dos_area(void)
     wine_anon_mmap( NULL, page_size, PROT_NONE, MAP_NORESERVE|MAP_FIXED );
     wine_mmap_add_reserved_area( NULL, dos_area_size );
 }
+
 
 
 /***********************************************************************
